package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import cn.com.infosec.asn1.crmf.CertId;
import cn.com.infosec.asn1.x509.CertificateList;
import java.util.Enumeration;

public class RevRepContent extends ASN1Encodable {
   private ASN1Sequence status;
   private ASN1Sequence revCerts;
   private ASN1Sequence crls;

   private RevRepContent(ASN1Sequence seq) {
      Enumeration seq1;
      this.status = ASN1Sequence.getInstance((seq1 = seq.getObjects()).nextElement());

      while(seq1.hasMoreElements()) {
         ASN1TaggedObject var2;
         if ((var2 = ASN1TaggedObject.getInstance(seq1.nextElement())).getTagNo() == 0) {
            this.revCerts = ASN1Sequence.getInstance(var2, true);
         } else {
            this.crls = ASN1Sequence.getInstance(var2, true);
         }
      }

   }

   public static RevRepContent getInstance(Object o) {
      if (o instanceof RevRepContent) {
         return (RevRepContent)o;
      } else if (o instanceof ASN1Sequence) {
         return new RevRepContent((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   private void addOptional(ASN1EncodableVector v, int tagNo, ASN1Encodable obj) {
      if (obj != null) {
         DERTaggedObject var4;
         var4 = new DERTaggedObject.<init>(true, tagNo, obj);
         v.add(var4);
      }

   }

   public PKIStatusInfo[] getStatus() {
      int var1;
      PKIStatusInfo[] var2 = new PKIStatusInfo[var1 = this.status.size()];

      for(int var3 = 0; var3 != var1; ++var3) {
         var2[var3] = PKIStatusInfo.getInstance(this.status.getObjectAt(var3));
      }

      return var2;
   }

   public CertId[] getRevCerts() {
      ASN1Sequence var1;
      if ((var1 = this.revCerts) == null) {
         return null;
      } else {
         int var4;
         CertId[] var2 = new CertId[var4 = var1.size()];

         for(int var3 = 0; var3 != var4; ++var3) {
            var2[var3] = CertId.getInstance(this.revCerts.getObjectAt(var3));
         }

         return var2;
      }
   }

   public CertificateList[] getCrls() {
      ASN1Sequence var1;
      if ((var1 = this.crls) == null) {
         return null;
      } else {
         int var4;
         CertificateList[] var2 = new CertificateList[var4 = var1.size()];

         for(int var3 = 0; var3 != var4; ++var3) {
            var2[var3] = CertificateList.getInstance(this.crls.getObjectAt(var3));
         }

         return var2;
      }
   }

   public DERObject toASN1Object() {
      RevRepContent var10000 = this;
      RevRepContent var10001 = this;
      RevRepContent var10002 = this;
      ASN1EncodableVector var1;
      ASN1EncodableVector var10004 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10004.add(this.status);
      ASN1Sequence var2 = this.revCerts;
      var10002.addOptional(var1, 0, var2);
      var2 = var10001.crls;
      var10000.addOptional(var1, 1, var2);
      return new DERSequence(var1);
   }
}
